/*
**  this code is not a example for well programming :-)
**  but for use of amigametaformat.library and createing AMF files
**  compile with 'sc write LINK'
*/

#include <intuition/intuition.h>
#include <graphics/view.h>
#include <dos/dos.h>
#include <exec/memory.h>
#include <exec/libraries.h>
#include <exec/types.h>
#include <libraries/iffparse.h>
#include <libraries/amigametaformat.h>
#include <pragmas/intuition_pragmas.h>
#include <pragmas/exec_pragmas.h>
#include <pragmas/dos_pragmas.h>
#include <pragmas/iffparse_pragmas.h>
#include <pragmas/amigametaformat_pragmas.h>
#include <stdio.h>
#include <string.h>

extern  struct  Library *SysBase;

void main()
{
          APTR        amf;
   struct IFFHandle  *iff;
   struct Screen     *scr;
   struct Window     *wnd;
   struct Library    *IFFParseBase;
   struct Library    *AmigaMetaFormatBase;
   struct Library    *IntuitionBase;
   struct Library    *DOSBase;
          STRPTR      arg;
          ULONG      *myarray, k, x, y;
          ULONG      mydata[10], myvalue[640], file;
          ULONG      pens[] = { ~0 };
          ULONG      clear[]  = { 0,  0,  AMF_SIZE-1, AMF_SIZE-1},
                     bgpen[]  = { 0,  0,  0},
                     fgpen1[]   = { -1, -1, -1},
                     fgpen2[]   = { 0,  -1, -1},
                     line1[]  = { 0,  30000,  20000,  30000},
                     line2[]  = { 20000,  30000,  30000,  20000},
                     line3[]  = { 30000,  20000,  15000,  20000},
                     line4[]  = { 13000,  20000,  10000,  20000},
                     line5[]  = { 10000,  20000,  0,  30000},
                     polyline1[]  = { 10000,  25000,  10000,  24000,
                                      25000,  10000,  26000,  11000,
                                      11000,  24000,  10000,  25000};

  if (DOSBase = OpenLibrary( "dos.library", 37))
  {
      if (IntuitionBase = OpenLibrary( "intuition.library", 37))
      {
          if (IFFParseBase = OpenLibrary( "iffparse.library", 37))
          {
              if (AmigaMetaFormatBase = OpenLibrary( "amigametaformat.library", 6))
              {
                  if (scr = OpenScreenTags( NULL,
                                            SA_Width,-1,
                                            SA_Height,-1,
                                            SA_Depth,4,
                                            SA_Pens,pens,
                                            SA_FullPalette,TRUE,
                                            SA_Type,CUSTOMSCREEN,
                                            SA_LikeWorkbench,TRUE,
                                            SA_SharePens,TRUE,
                                            TAG_DONE))
                  {
                      if (wnd = OpenWindowTags( NULL,
                                                WA_CustomScreen,scr,
                                                WA_IDCMP,IDCMP_MOUSEBUTTONS,
                                                WA_Title,"AMF file creater (simple)",
                                                TAG_DONE))
                      {
                          mydata[0] = (ULONG )wnd;
                          mydata[1] = (ULONG )scr->ViewPort.ColorMap;

                          if (amf = AmfOpen( AMF_WINDOW, mydata))
                          {
                              /* First some basic predefined figures */
                              AmfFunction( amf, bgpen, AMF_SETBGPEN, 3);
                              AmfFunction( amf, fgpen1, AMF_SETFGPEN, 3);
                              AmfFunction( amf, clear, AMF_CLEAR_REGION, 4);
                              AmfFunction( amf, line1, AMF_LINE, 4);
                              AmfFunction( amf, line2, AMF_LINE, 4);
                              AmfFunction( amf, line3, AMF_LINE, 4);
                              AmfFunction( amf, line4, AMF_LINE, 4);
                              AmfFunction( amf, line5, AMF_LINE, 4);
                              AmfFunction( amf, polyline1, AMF_FILL_POLY, 12);

                              /* now drawing a function */
                              k = 0;
                              x = 0;
                              y = x - ((x/10) * 10);
                              myvalue[ 2*k + 0] = x * 45 + 500;
                              myvalue[ 2*k + 1] = y * 1500 + 500;
                              for (x = 1; x<320; x++)
                              {
                                  y = x - ((x/10) * 10);
                                  k++;
                                  myvalue[ 2*k + 0] = x * 45 + 500;
                                  myvalue[ 2*k + 1] = y * 1500 + 500;
                              }
                              AmfFunction( amf, fgpen2, AMF_SETFGPEN, 3);
                              AmfFunction( amf, myvalue, AMF_POLYGON, 640);

                              /* drawing a x- and a y- axe */
                              if (myarray = AllocVec( 16, MEMF_CLEAR))
                              {
                                  AmfFunction( amf, fgpen1, AMF_SETFGPEN, 3);
                                  myarray[0] = 0;
                                  myarray[1] = 8000;
                                  myarray[2] = 16000;
                                  myarray[3] = 8000;
                                  AmfFunction( amf, myarray, AMF_LINE, 4);
                                  myarray[0] = 8000;
                                  myarray[1] = 0;
                                  myarray[2] = 8000;
                                  myarray[3] = 16000;
                                  AmfFunction( amf, myarray, AMF_LINE, 4);
                                  FreeVec(myarray);
                              }
                              AmfClose(amf);
                          }

                          /* save all things also to AMF file */
                          arg = GetArgStr();
                          arg[strlen(arg)-1] = 0;
                          file = Open( arg, MODE_OLDFILE);
                          if (file == 0)
                          {
                              if (file = Open( arg, MODE_NEWFILE))
                              {
                                  if (iff = AllocIFF())
                                  {
                                      InitIFFasDOS( iff);
                                      iff->iff_Stream = file;
                                      if (!OpenIFF( iff, IFFF_WRITE))
                                      {
                                          mydata[0] = (ULONG )iff;
                                          mydata[1] = wnd->Width;
                                          mydata[2] = wnd->Height;

                                          /* First some basic predefined figures */
                                          if (amf = AmfOpen( AMF_FILE, mydata))
                                          {
                                              AmfFunction( amf, bgpen, AMF_SETBGPEN, 3);
                                              AmfFunction( amf, fgpen1, AMF_SETFGPEN, 3);
                                              AmfFunction( amf, clear, AMF_CLEAR_REGION, 4);
                                              AmfFunction( amf, line1, AMF_LINE, 4);
                                              AmfFunction( amf, line2, AMF_LINE, 4);
                                              AmfFunction( amf, line3, AMF_LINE, 4);
                                              AmfFunction( amf, line4, AMF_LINE, 4);
                                              AmfFunction( amf, line5, AMF_LINE, 4);
                                              AmfFunction( amf, polyline1, AMF_FILL_POLY, 12);

                                              /* now drawing a function */
                                              /* the array are still filled */
                                              AmfFunction( amf, fgpen2, AMF_SETFGPEN, 3);
                                              AmfFunction( amf, myvalue, AMF_POLYGON, 640);

                                              /* drawing a x- and a y- axe */
                                              if (myarray = AllocVec( 16, MEMF_CLEAR))
                                              {
                                                  AmfFunction( amf, fgpen1, AMF_SETFGPEN, 3);
                                                  myarray[0] = 0;
                                                  myarray[1] = 8000;
                                                  myarray[2] = 16000;
                                                  myarray[3] = 8000;
                                                  AmfFunction( amf, myarray, AMF_LINE, 4);
                                                  myarray[0] = 8000;
                                                  myarray[1] = 0;
                                                  myarray[2] = 8000;
                                                  myarray[3] = 16000;
                                                  AmfFunction( amf, myarray, AMF_LINE, 4);
                                                  FreeVec(myarray);
                                              }
                                              AmfClose(amf);
                                          }
                                          CloseIFF( iff);
                                      }
                                      FreeIFF( iff);
                                  }
                                  Close( file);
                              }else
                              {
                                  printf( "can`t open file: \"%s\"\n" , arg);
                              }
                          }else
                          {
                              printf( "file: \"%s\" exist\n" , arg);
                              Close(file);
                          }
                          WaitPort( wnd->UserPort);
                          CloseWindow( wnd);
                      }else
                      {
                          printf( "no window\n");
                      }
                      CloseScreen( scr);
                  }else
                  {
                      printf( "no screen\n");
                  }
                  CloseLibrary( AmigaMetaFormatBase);
              }else
              {
                  printf( "no amigametaformat.library 6+\n");
              }
              CloseLibrary( IFFParseBase);
          }else
          {
              printf( "no iffparse.library 37+\n");
          }
          CloseLibrary( IntuitionBase);
      }else
      {
          printf( "please use OS 2.0 or better for this\n");
      }
      CloseLibrary( DOSBase);
  }else
  {
      printf( "please use OS 2.0 or better for this\n");
  }
}

