OPT MODULE
OPT EXPORT

CONST AMF_SIZE          =32768,
      AMF_WINDOW        =1,
      AMF_STRIP         =2,
      AMF_FILE          =3,
      AMF_REGION        =4,
      AMF_EPS           =5,
      AMF_GEM           =6,
      AMF_CGM           =7,
      AMF_WORDWORTH     =8,
      AMF_HPGL          =9,
      AMF_DR2D          =10,
      AMF_AI            =11,
      AMF_WMF           =12,
      AMF_JMF           =13,

      AMF_NO_ERROR            =0, /* no error */
      AMF_ERROR_NO_MEM        =1, /* not enough memory */
      AMF_ERROR_NOT_SUPPORTED =2, /* this function are not supported in this driver */
      AMF_ERROR_WRONG_ARGS    =3, /* not enough arguments for this function */
      AMF_ERROR_OTHER         =4, /* misc. error */

      AMF_CLEAR_REGION     =0,   /* xmin,ymin,xmax,ymax */
      ->AMF_MOVE_TO          =1,   /* x,y */
      ->AMF_DRAW_TO          =2,   /* x,y */
      AMF_LINE             =3,   /* xstart,ystart,xend,yend */
      ->AMF_PLOT             =4,   /* x,y */
      AMF_TEXT             =5,   /* x,y,alpha,string:CHARS */
      AMF_ELLIPSE          =6,   /* x,y,xsize,ysize */
      AMF_BOX              =7,   /* xstart,ystart,xend,yend */
      AMF_FILL_ELLIPSE     =8,   /* x,y,xsize,ysize */
      AMF_FILL_BOX         =9,   /* xmin,ymin,xmax,ymax */
      ->AMF_FILL             =10,  /* x,y */
      AMF_POLYGON          =11,  /* x,y-Paare */
      AMF_BITMAP_PIC       =12,
      AMF_ARC              =13,  /* x,y,r,alpha,beta */
      AMF_MARK             =14,  /* x,y */
      AMF_CURVE            =15,  /* n* [x1,y1,x2,y2,x3,y3,x4,y4] */
      AMF_FILL_POLY        =16,  /* x,y-Paare */
      AMF_ROUNDED          =17,  /* xstart,ystart,xend,yend */
      AMF_PIE              =18,  /* x,y,xsize,ysize,alpha,beta */
      AMF_FILL_ROUNDED     =19,  /* xstart,ystart,xend,yend */
      AMF_FILL_PIE         =20,  /* x,y,xsize,ysize,alpha,beta */
      AMF_FILL_CURVE       =21,  /* n* [x1,y1,x2,y2,x3,y3,x4,y4] */

      AMF_FONT             =100, /* size,style,fontname:CHARS */
      AMF_SETFGPEN         =101, /* r,g,b */
      AMF_SETBGPEN         =102, /* r,g,b */
      AMF_SETDRMODE        =103, /* mode */
      AMF_SETLINEPAT       =104, /* patnr */
      AMF_SETLINEWIDTH     =105, /* width */
      AMF_SETFONT          =106, /* size,style,fontname:CHARS */
      AMF_SETFILLPAT       =107, /* patnr */
      AMF_SETMARKSIZE      =108, /* size */
      AMF_SETMARKTYPE      =109, /* type */
      AMF_SETDPI           =110, /* xdpi,ydpi */

      AMF_GETFONTHEIGHT    =200,
      AMF_GETSTRINGLENGHT  =201, /* string:CHARS */
      AMF_GETBASELINE      =202


